Index: NEMO/trunk/src/OCE/ZDF/zdfosm.F90
===================================================================
--- NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14903)
+++ NEMO/trunk/src/OCE/ZDF/zdfosm.F90	(revision 14921)
@@ -2390,176 +2921,193 @@
       !! References: Fox-Kemper et al., JPO, 38, 1145-1165, 2008
       !!             Fox-Kemper and Ferrari, JPO, 38, 1166-1179, 2008
-
-      INTEGER, DIMENSION(jpi,jpj)      :: mld_prof
-      REAL(wp), DIMENSION(jpi,jpj)     :: hmle, zhmle, zwb_fk, zvel_mle, zdiff_mle
-      INTEGER  ::   ji, jj, jk          ! dummy loop indices
-      INTEGER  ::   ii, ij, ik, jkb, jkb1  ! local integers
-      INTEGER , DIMENSION(jpi,jpj)     :: inml_mle
-      REAL(wp) ::  ztmp, zdbdz, zdtdz, zdsdz, zthermal,zbeta, zbuoy, zdb_mle
-
-   ! Calculate vertical buoyancy, heat and salinity fluxes due to MLE.
-
-      DO_2D( 0, 0, 0, 0 )
-       IF ( lconv(ji,jj) ) THEN
-          ztmp =  r1_ft(ji,jj) *  MIN( 111.e3_wp , e1u(ji,jj) ) / rn_osm_mle_lf
-   ! This velocity scale, defined in Fox-Kemper et al (2008), is needed for calculating dhdt.
-          zvel_mle(ji,jj) = zdbds_mle(ji,jj) * ztmp * hmle(ji,jj) * tmask(ji,jj,1)
-          zdiff_mle(ji,jj) = 5.e-4_wp * rn_osm_mle_ce * ztmp * zdbds_mle(ji,jj) * zhmle(ji,jj)**2
-       ENDIF
-      END_2D
-   ! Timestep mixed layer eddy depth.
-      DO_2D( 0, 0, 0, 0 )
-        IF ( lmle(ji,jj) ) THEN  ! MLE layer growing.
-! Buoyancy gradient at base of MLE layer.
-           zthermal = rab_n(ji,jj,1,jp_tem)
-           zbeta    = rab_n(ji,jj,1,jp_sal)
-           jkb = mld_prof(ji,jj)
-           jkb1 = MIN(jkb + 1, mbkt(ji,jj))
-!
-           zbuoy = grav * ( zthermal * ts(ji,jj,mld_prof(ji,jj)+2,jp_tem,Kmm) - zbeta * ts(ji,jj,mld_prof(ji,jj)+2,jp_sal,Kmm) )
-           zdb_mle = zb_bl(ji,jj) - zbuoy
-! Timestep hmle.
-           hmle(ji,jj) = hmle(ji,jj) + zwb0(ji,jj) * rn_Dt / zdb_mle
-        ELSE
-           IF ( zhmle(ji,jj) > zhbl(ji,jj) ) THEN
-              hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt / rn_osm_mle_tau
-           ELSE
-              hmle(ji,jj) = hmle(ji,jj) - 10.0 * ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt /rn_osm_mle_tau
-           ENDIF
-        ENDIF
-        hmle(ji,jj) = MIN(hmle(ji,jj), ht(ji,jj))
-       IF(ln_osm_hmle_limit) hmle(ji,jj) = MIN(hmle(ji,jj), MAX(rn_osm_hmle_limit,1.2*hbl(ji,jj)) )
-      END_2D
-
-      mld_prof = 4
-      DO_3D( 0, 0, 0, 0, 5, jpkm1 )
-      IF ( hmle(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) mld_prof(ji,jj) = MIN(mbkt(ji,jj), jk)
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER,                            INTENT(in   ) ::   Kmm         ! Time-level index
+      REAL(wp), DIMENSION(A2D(nn_hls)),   INTENT(in   ) ::   pmld        ! == Estimated FK BLD used for MLE horiz gradients == !
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   phmle       ! MLE depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   pvel_mle    ! Velocity scale for dhdt with stable ML and FK
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(inout) ::   pdiff_mle   ! Extra MLE vertical diff
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pdbds_mle   ! Magnitude of horizontal buoyancy gradient
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   phbl        ! BL depth
+      REAL(wp), DIMENSION(A2D(nn_hls-1)), INTENT(in   ) ::   pwb0tot     ! Total surface buoyancy flux including insolation
+      !!
+      INTEGER  ::   ji, jj, jk   ! Dummy loop indices
+      REAL(wp) ::   ztmp
+      REAL(wp) ::   zdbdz
+      REAL(wp) ::   zdtdz
+      REAL(wp) ::   zdsdz
+      REAL(wp) ::   zthermal
+      REAL(wp) ::   zbeta
+      REAL(wp) ::   zbuoy
+      REAL(wp) ::   zdb_mle
+      !!----------------------------------------------------------------------
+      !
+      ! Calculate vertical buoyancy, heat and salinity fluxes due to MLE
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_conv(ji,jj) ) THEN
+            ztmp =  r1_ft(ji,jj) * MIN( 111e3_wp, e1u(ji,jj) ) / rn_osm_mle_lf
+            ! This velocity scale, defined in Fox-Kemper et al (2008), is needed for calculating dhdt
+            pvel_mle(ji,jj)  = pdbds_mle(ji,jj) * ztmp * hmle(ji,jj) * tmask(ji,jj,1)
+            pdiff_mle(ji,jj) = 5e-4_wp * rn_osm_mle_ce * ztmp * pdbds_mle(ji,jj) * phmle(ji,jj)**2
+         END IF
+      END_2D
+      ! Timestep mixed layer eddy depth
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         IF ( l_mle(ji,jj) ) THEN   ! MLE layer growing
+            ! Buoyancy gradient at base of MLE layer
+            zthermal = rab_n(ji,jj,1,jp_tem)
+            zbeta    = rab_n(ji,jj,1,jp_sal)
+            zbuoy = grav * ( zthermal * ts(ji,jj,mld_prof(ji,jj)+2,jp_tem,Kmm) -   &
+               &             zbeta    * ts(ji,jj,mld_prof(ji,jj)+2,jp_sal,Kmm) )
+            zdb_mle = av_b_bl(ji,jj) - zbuoy
+            ! Timestep hmle
+            hmle(ji,jj) = hmle(ji,jj) + pwb0tot(ji,jj) * rn_Dt / zdb_mle
+         ELSE
+            IF ( phmle(ji,jj) > phbl(ji,jj) ) THEN
+               hmle(ji,jj) = hmle(ji,jj) - ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt / rn_osm_mle_tau
+            ELSE
+               hmle(ji,jj) = hmle(ji,jj) - 10.0_wp * ( hmle(ji,jj) - hbl(ji,jj) ) * rn_Dt / rn_osm_mle_tau
+            END IF
+         END IF
+         hmle(ji,jj) = MAX( MIN( hmle(ji,jj), ht(ji,jj) ), gdepw(ji,jj,4,Kmm) )
+         IF ( ln_osm_hmle_limit ) hmle(ji,jj) = MIN( hmle(ji,jj), rn_osm_hmle_limit*hbl(ji,jj) )
+         hmle(ji,jj) = pmld(ji,jj)   ! For now try just set hmle to pmld
+      END_2D
+      !
+      DO_3D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1, 5, jpkm1 )
+         IF ( hmle(ji,jj) >= gdepw(ji,jj,jk,Kmm) ) mld_prof(ji,jj) = MIN( mbkt(ji,jj), jk )
       END_3D
-      DO_2D( 0, 0, 0, 0 )
-         zhmle(ji,jj) = gdepw(ji,jj, mld_prof(ji,jj),Kmm)
-      END_2D
-END SUBROUTINE zdf_osm_mle_parameters
-
-END SUBROUTINE zdf_osm
-
+      DO_2D_OVR( nn_hls-1, nn_hls-1, nn_hls-1, nn_hls-1 )
+         phmle(ji,jj) = gdepw(ji,jj,mld_prof(ji,jj),Kmm)
+      END_2D
+      !
+   END SUBROUTINE zdf_osm_mle_parameters
 
    SUBROUTINE zdf_osm_init( Kmm )
-     !!----------------------------------------------------------------------
-     !!                  ***  ROUTINE zdf_osm_init  ***
-     !!
-     !! ** Purpose :   Initialization of the vertical eddy diffivity and
-     !!      viscosity when using a osm turbulent closure scheme
-     !!
-     !! ** Method  :   Read the namosm namelist and check the parameters
-     !!      called at the first timestep (nit000)
-     !!
-     !! ** input   :   Namlist namosm
-     !!----------------------------------------------------------------------
-     INTEGER, INTENT(in)   ::   Kmm       ! time level
-     INTEGER  ::   ios            ! local integer
-     INTEGER  ::   ji, jj, jk     ! dummy loop indices
-     REAL z1_t2
-     !!
-     NAMELIST/namzdf_osm/ ln_use_osm_la, rn_osm_la, rn_osm_dstokes, nn_ave &
-          & ,nn_osm_wave, ln_dia_osm, rn_osm_hbl0, rn_zdfosm_adjust_sd &
-          & ,ln_kpprimix, rn_riinfty, rn_difri, ln_convmix, rn_difconv, nn_osm_wave &
-          & ,nn_osm_SD_reduce, ln_osm_mle, rn_osm_hblfrac, rn_osm_bl_thresh, ln_zdfosm_ice_shelter
-! Namelist for Fox-Kemper parametrization.
-      NAMELIST/namosm_mle/ nn_osm_mle, rn_osm_mle_ce, rn_osm_mle_lf, rn_osm_mle_time, rn_osm_mle_lat,&
-           & rn_osm_mle_rho_c, rn_osm_mle_thresh, rn_osm_mle_tau, ln_osm_hmle_limit, rn_osm_hmle_limit
-
-     !!----------------------------------------------------------------------
-     !
-     READ  ( numnam_ref, namzdf_osm, IOSTAT = ios, ERR = 901)
-901  IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_osm in reference namelist' )
-
-     READ  ( numnam_cfg, namzdf_osm, IOSTAT = ios, ERR = 902 )
-902  IF( ios >  0 ) CALL ctl_nam ( ios , 'namzdf_osm in configuration namelist' )
-     IF(lwm) WRITE ( numond, namzdf_osm )
-
-     IF(lwp) THEN                    ! Control print
-        WRITE(numout,*)
-        WRITE(numout,*) 'zdf_osm_init : OSMOSIS Parameterisation'
-        WRITE(numout,*) '~~~~~~~~~~~~'
-        WRITE(numout,*) '   Namelist namzdf_osm : set osm mixing parameters'
-        WRITE(numout,*) '     Use  rn_osm_la                                ln_use_osm_la = ', ln_use_osm_la
-        WRITE(numout,*) '     Use  MLE in OBL, i.e. Fox-Kemper param        ln_osm_mle = ', ln_osm_mle
-        WRITE(numout,*) '     Turbulent Langmuir number                     rn_osm_la   = ', rn_osm_la
-        WRITE(numout,*) '     Stokes drift reduction factor                 rn_zdfosm_adjust_sd   = ', rn_zdfosm_adjust_sd
-        WRITE(numout,*) '     Initial hbl for 1D runs                       rn_osm_hbl0   = ', rn_osm_hbl0
-        WRITE(numout,*) '     Depth scale of Stokes drift                   rn_osm_dstokes = ', rn_osm_dstokes
-        WRITE(numout,*) '     horizontal average flag                       nn_ave      = ', nn_ave
-        WRITE(numout,*) '     Stokes drift                                  nn_osm_wave = ', nn_osm_wave
-        SELECT CASE (nn_osm_wave)
-        CASE(0)
-           WRITE(numout,*) '     calculated assuming constant La#=0.3'
-        CASE(1)
-           WRITE(numout,*) '     calculated from Pierson Moskowitz wind-waves'
-        CASE(2)
-           WRITE(numout,*) '     calculated from ECMWF wave fields'
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE zdf_osm_init  ***
+      !!
+      !! ** Purpose :   Initialization of the vertical eddy diffivity and
+      !!      viscosity when using a osm turbulent closure scheme
+      !!
+      !! ** Method  :   Read the namosm namelist and check the parameters
+      !!      called at the first timestep (nit000)
+      !!
+      !! ** input   :   Namlists namzdf_osm and namosm_mle
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in   ) ::   Kmm   ! Time level
+      !!
+      INTEGER  ::   ios            ! Local integer
+      INTEGER  ::   ji, jj, jk     ! Dummy loop indices
+      REAL(wp) ::   z1_t2
+      !!
+      REAL(wp), PARAMETER ::   pp_large = -1e10_wp
+      !!
+      NAMELIST/namzdf_osm/ ln_use_osm_la,    rn_osm_la,      rn_osm_dstokes,      nn_ave,                nn_osm_wave,        &
+         &                 ln_dia_osm,       rn_osm_hbl0,    rn_zdfosm_adjust_sd, ln_kpprimix,           rn_riinfty,         &
+         &                 rn_difri,         ln_convmix,     rn_difconv,          nn_osm_wave,           nn_osm_SD_reduce,   &
+         &                 ln_osm_mle,       rn_osm_hblfrac, rn_osm_bl_thresh,    ln_zdfosm_ice_shelter
+      !! Namelist for Fox-Kemper parametrization
+      NAMELIST/namosm_mle/ nn_osm_mle,       rn_osm_mle_ce,     rn_osm_mle_lf,  rn_osm_mle_time,  rn_osm_mle_lat,   &
+         &                 rn_osm_mle_rho_c, rn_osm_mle_thresh, rn_osm_mle_tau, ln_osm_hmle_limit, rn_osm_hmle_limit
+      !!----------------------------------------------------------------------
+      !
+      READ  ( numnam_ref, namzdf_osm, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namzdf_osm in reference namelist' )
+
+      READ  ( numnam_cfg, namzdf_osm, IOSTAT = ios, ERR = 902 )
+902   IF( ios >  0 ) CALL ctl_nam ( ios , 'namzdf_osm in configuration namelist' )
+      IF(lwm) WRITE ( numond, namzdf_osm )
+
+      IF(lwp) THEN                    ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'zdf_osm_init : OSMOSIS Parameterisation'
+         WRITE(numout,*) '~~~~~~~~~~~~'
+         WRITE(numout,*) '   Namelist namzdf_osm : set osm mixing parameters'
+         WRITE(numout,*) '      Use  rn_osm_la                                     ln_use_osm_la         = ', ln_use_osm_la
+         WRITE(numout,*) '      Use  MLE in OBL, i.e. Fox-Kemper param             ln_osm_mle            = ', ln_osm_mle
+         WRITE(numout,*) '      Turbulent Langmuir number                          rn_osm_la             = ', rn_osm_la
+         WRITE(numout,*) '      Stokes drift reduction factor                      rn_zdfosm_adjust_sd   = ', rn_zdfosm_adjust_sd
+         WRITE(numout,*) '      Initial hbl for 1D runs                            rn_osm_hbl0           = ', rn_osm_hbl0
+         WRITE(numout,*) '      Depth scale of Stokes drift                        rn_osm_dstokes        = ', rn_osm_dstokes
+         WRITE(numout,*) '      Horizontal average flag                            nn_ave                = ', nn_ave
+         WRITE(numout,*) '      Stokes drift                                       nn_osm_wave           = ', nn_osm_wave
+         SELECT CASE (nn_osm_wave)
+         CASE(0)
+            WRITE(numout,*) '      Calculated assuming constant La#=0.3'
+         CASE(1)
+            WRITE(numout,*) '      Calculated from Pierson Moskowitz wind-waves'
+         CASE(2)
+            WRITE(numout,*) '      Calculated from ECMWF wave fields'
          END SELECT
-        WRITE(numout,*) '     Stokes drift reduction                        nn_osm_SD_reduce', nn_osm_SD_reduce
-        WRITE(numout,*) '     fraction of hbl to average SD over/fit'
-        WRITE(numout,*) '     exponential with nn_osm_SD_reduce = 1 or 2    rn_osm_hblfrac =  ', rn_osm_hblfrac
-        SELECT CASE (nn_osm_SD_reduce)
-        CASE(0)
-           WRITE(numout,*) '     No reduction'
-        CASE(1)
-           WRITE(numout,*) '     Average SD over upper rn_osm_hblfrac of BL'
-        CASE(2)
-           WRITE(numout,*) '     Fit exponential to slope rn_osm_hblfrac of BL'
-        END SELECT
-        WRITE(numout,*) '     reduce surface SD and depth scale under ice   ln_zdfosm_ice_shelter=', ln_zdfosm_ice_shelter
-        WRITE(numout,*) '     Output osm diagnostics                       ln_dia_osm  = ',  ln_dia_osm
-        WRITE(numout,*) '         Threshold used to define BL              rn_osm_bl_thresh  = ', rn_osm_bl_thresh, 'm^2/s'
-        WRITE(numout,*) '     Use KPP-style shear instability mixing       ln_kpprimix = ', ln_kpprimix
-        WRITE(numout,*) '     local Richardson Number limit for shear instability rn_riinfty = ', rn_riinfty
-        WRITE(numout,*) '     maximum shear diffusivity at Rig = 0    (m2/s) rn_difri = ', rn_difri
-        WRITE(numout,*) '     Use large mixing below BL when unstable       ln_convmix = ', ln_convmix
-        WRITE(numout,*) '     diffusivity when unstable below BL     (m2/s) rn_difconv = ', rn_difconv
-     ENDIF
-
-
-     !                              ! Check wave coupling settings !
-     !                         ! Further work needed - see ticket #2447 !
-     IF( nn_osm_wave == 2 ) THEN
-        IF (.NOT. ( ln_wave .AND. ln_sdw )) &
-           & CALL ctl_stop( 'zdf_osm_init : ln_zdfosm and nn_osm_wave=2, ln_wave and ln_sdw must be true' )
-     END IF
-
-     !                              ! allocate zdfosm arrays
-     IF( zdf_osm_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'zdf_osm_init : unable to allocate arrays' )
-
-
-     IF( ln_osm_mle ) THEN
-! Initialise Fox-Kemper parametrization
+         WRITE(numout,*) '      Stokes drift reduction                             nn_osm_SD_reduce      = ', nn_osm_SD_reduce
+         WRITE(numout,*) '      Fraction of hbl to average SD over/fit'
+         WRITE(numout,*) '      Exponential with nn_osm_SD_reduce = 1 or 2         rn_osm_hblfrac        = ', rn_osm_hblfrac
+         SELECT CASE (nn_osm_SD_reduce)
+         CASE(0)
+            WRITE(numout,*) '     No reduction'
+         CASE(1)
+            WRITE(numout,*) '     Average SD over upper rn_osm_hblfrac of BL'
+         CASE(2)
+            WRITE(numout,*) '     Fit exponential to slope rn_osm_hblfrac of BL'
+         END SELECT
+         WRITE(numout,*) '     Reduce surface SD and depth scale under ice         ln_zdfosm_ice_shelter = ', ln_zdfosm_ice_shelter
+         WRITE(numout,*) '     Output osm diagnostics                              ln_dia_osm            = ', ln_dia_osm
+         WRITE(numout,*) '         Threshold used to define BL                     rn_osm_bl_thresh      = ', rn_osm_bl_thresh,   &
+            &            'm^2/s'
+         WRITE(numout,*) '     Use KPP-style shear instability mixing              ln_kpprimix           = ', ln_kpprimix
+         WRITE(numout,*) '     Local Richardson Number limit for shear instability rn_riinfty            = ', rn_riinfty
+         WRITE(numout,*) '     Maximum shear diffusivity at Rig = 0 (m2/s)         rn_difri              = ', rn_difri
+         WRITE(numout,*) '     Use large mixing below BL when unstable             ln_convmix            = ', ln_convmix
+         WRITE(numout,*) '     Diffusivity when unstable below BL (m2/s)           rn_difconv            = ', rn_difconv
+      ENDIF
+      !
+      !                              ! Check wave coupling settings !
+      !                         ! Further work needed - see ticket #2447 !
+      IF ( nn_osm_wave == 2 ) THEN
+         IF (.NOT. ( ln_wave .AND. ln_sdw )) &
+            & CALL ctl_stop( 'zdf_osm_init : ln_zdfosm and nn_osm_wave=2, ln_wave and ln_sdw must be true' )
+      END IF
+      !
+      ! Flags associated with diagnostic output
+      IF ( ln_dia_osm .AND. ( iom_use("zdudz_pyc") .OR. iom_use("zdvdz_pyc") ) )                            ln_dia_pyc_shr = .TRUE.
+      IF ( ln_dia_osm .AND. ( iom_use("zdtdz_pyc") .OR. iom_use("zdsdz_pyc") .OR. iom_use("zdbdz_pyc" ) ) ) ln_dia_pyc_scl = .TRUE.
+      !
+      ! Allocate zdfosm arrays
+      IF( zdf_osm_alloc() /= 0 ) CALL ctl_stop( 'STOP', 'zdf_osm_init : unable to allocate arrays' )
+      !
+      IF( ln_osm_mle ) THEN   ! Initialise Fox-Kemper parametrization
          READ  ( numnam_ref, namosm_mle, IOSTAT = ios, ERR = 903)
-903      IF( ios /= 0 )   CALL ctl_nam ( ios , 'namosm_mle in reference namelist')
-
+903      IF( ios /= 0 ) CALL ctl_nam( ios, 'namosm_mle in reference namelist' )
          READ  ( numnam_cfg, namosm_mle, IOSTAT = ios, ERR = 904 )
-904      IF( ios >  0 )   CALL ctl_nam ( ios , 'namosm_mle in configuration namelist')
+904      IF( ios >  0 ) CALL ctl_nam( ios, 'namosm_mle in configuration namelist' )
          IF(lwm) WRITE ( numond, namosm_mle )
-
-         IF(lwp) THEN                     ! Namelist print
+         !
+         IF(lwp) THEN   ! Namelist print
             WRITE(numout,*)
             WRITE(numout,*) 'zdf_osm_init : initialise mixed layer eddy (MLE)'
             WRITE(numout,*) '~~~~~~~~~~~~~'
             WRITE(numout,*) '   Namelist namosm_mle : '
-            WRITE(numout,*) '         MLE type: =0 standard Fox-Kemper ; =1 new formulation        nn_osm_mle    = ', nn_osm_mle
-            WRITE(numout,*) '         magnitude of the MLE (typical value: 0.06 to 0.08)           rn_osm_mle_ce    = ', rn_osm_mle_ce
-            WRITE(numout,*) '         scale of ML front (ML radius of deformation) (nn_osm_mle=0)      rn_osm_mle_lf     = ', rn_osm_mle_lf, 'm'
-            WRITE(numout,*) '         maximum time scale of MLE                    (nn_osm_mle=0)      rn_osm_mle_time   = ', rn_osm_mle_time, 's'
-            WRITE(numout,*) '         reference latitude (degrees) of MLE coef.    (nn_osm_mle=1)      rn_osm_mle_lat    = ', rn_osm_mle_lat, 'deg'
-            WRITE(numout,*) '         Density difference used to define ML for FK              rn_osm_mle_rho_c  = ', rn_osm_mle_rho_c
-            WRITE(numout,*) '         Threshold used to define MLE for FK                      rn_osm_mle_thresh  = ', rn_osm_mle_thresh, 'm^2/s'
-            WRITE(numout,*) '         Timescale for OSM-FK                                         rn_osm_mle_tau  = ', rn_osm_mle_tau, 's'
-            WRITE(numout,*) '         switch to limit hmle                                      ln_osm_hmle_limit  = ', ln_osm_hmle_limit
-            WRITE(numout,*) '         fraction of zmld to limit hmle to if ln_osm_hmle_limit =.T.  rn_osm_hmle_limit = ', rn_osm_hmle_limit
-         ENDIF         !
-     ENDIF
+            WRITE(numout,*) '      MLE type: =0 standard Fox-Kemper ; =1 new formulation   nn_osm_mle        = ', nn_osm_mle
+            WRITE(numout,*) '      Magnitude of the MLE (typical value: 0.06 to 0.08)      rn_osm_mle_ce     = ', rn_osm_mle_ce
+            WRITE(numout,*) '      Scale of ML front (ML radius of deform.) (nn_osm_mle=0) rn_osm_mle_lf     = ', rn_osm_mle_lf,    &
+               &            'm'
+            WRITE(numout,*) '      Maximum time scale of MLE                (nn_osm_mle=0) rn_osm_mle_time   = ',   &
+               &            rn_osm_mle_time, 's'
+            WRITE(numout,*) '      Reference latitude (deg) of MLE coef.    (nn_osm_mle=1) rn_osm_mle_lat    = ', rn_osm_mle_lat,   &
+               &            'deg'
+            WRITE(numout,*) '      Density difference used to define ML for FK             rn_osm_mle_rho_c  = ', rn_osm_mle_rho_c
+            WRITE(numout,*) '      Threshold used to define MLE for FK                     rn_osm_mle_thresh = ',   &
+               &            rn_osm_mle_thresh, 'm^2/s'
+            WRITE(numout,*) '      Timescale for OSM-FK                                    rn_osm_mle_tau    = ', rn_osm_mle_tau, 's'
+            WRITE(numout,*) '      Switch to limit hmle                                    ln_osm_hmle_limit = ', ln_osm_hmle_limit
+            WRITE(numout,*) '      hmle limit (fraction of zmld) (ln_osm_hmle_limit = .T.) rn_osm_hmle_limit = ', rn_osm_hmle_limit
+         END IF
+      END IF
       !
       IF(lwp) THEN
          WRITE(numout,*)
-         IF( ln_osm_mle ) THEN
+         IF ( ln_osm_mle ) THEN
             WRITE(numout,*) '   ==>>>   Mixed Layer Eddy induced transport added to OSMOSIS BL calculation'
             IF( nn_osm_mle == 0 )   WRITE(numout,*) '              Fox-Kemper et al 2010 formulation'
